<template>

<!-- App.vue -->
	<v-app>
		<v-navigation-drawer app v-model="drawer" responsive>

			<v-list>				
				
				<v-list-item three-line v-if="!isGuest">					
					<v-list-item-avatar>
						<v-img v-bind:src="whoAmI.avatar"></v-img>	
					</v-list-item-avatar>
					<v-list-item-content>
						<v-list-item-title>{{whoAmI.name}}</v-list-item-title>
						<v-list-item-subtitle>{{whoAmI.email}}</v-list-item-subtitle>
					</v-list-item-content>					
					
				</v-list-item>				

				<div class="pa-2" v-if="isGuest">
					<v-btn block color="primary" class="mb-1" v-on:click.native="setComponent({component:'my-login',status:true})">
						<v-icon left>mdi-lock</v-icon>
						Login
					</v-btn>
					<v-btn block color="success" v-on:click.native="setComponent({component:'my-registration', status:true})" >
						<v-icon left>mdi-account</v-icon>
						Register
					</v-btn>
				</div>

				<v-divider></v-divider>

				<v-list-item v-for="(menu, index) in menus" v-bind:key="'menu-'+index" v-bind:to="menu.route">
						<v-list-item-icon>
							<v-icon left>{{menu.icon}}</v-icon>
						</v-list-item-icon>	
						<v-list-item-content>
							<v-list-item-title left>{{menu.title}}</v-list-item-title>
						</v-list-item-content>
				</v-list-item>
				
			</v-list>

			<v-btn block color="warning" dark v-on:click="$router.push({name:'chat'})">
				<v-icon left>mdi-message</v-icon>
						Chat Room
			</v-btn>	

			<template v-slot:append v-if="!isGuest">
				<div class="pa-2">
					<v-btn block color="red" dark v-on:click="doLogout">
						<v-icon left>mdi-lock</v-icon>
						Logout
					</v-btn>
				</div>					
			</template>

		</v-navigation-drawer>

		<!--for home-->
		<v-app-bar app color="brown lighten-1" light v-if="isHome">
			<v-app-bar-nav-icon v-on:click.stop="drawer = !drawer"></v-app-bar-nav-icon>
			
			<v-toolbar-title>{{title}}</v-toolbar-title>

			<v-spacer></v-spacer>

			<v-btn 	icon color="white" v-if="donationCounter>0"
					v-on:click="setComponent({component:'tx-component', status:true})"
			>
				<v-badge color="orange" overlap>
					<template v-slot:badge>
						<span>{{donationCounter}}</span>
					</template>
					<v-icon>mdi-cash-multiple</v-icon>
				</v-badge>
			</v-btn>
			<v-btn icon v-else>
				<v-icon>mdi-cash-multiple</v-icon>
			</v-btn>
			<v-text-field 	slot="extension" hide-details 
					append-icon="mdi-microphone" 
					flat label="search"
					prepend-inner-icon="mdi-magnify"
					solo-inverted
					v-on:click="setComponent({component:'search-campaign', status:true})"
					>
					
			</v-text-field>

			<!--reuseable component with keep alive and persistent-->
			
			<keep-alive>
				<v-dialog
					v-model="componentStatus"
					fullscreen
					hide-overlay
					persistent 
					transition="dialog-bottom-transition"
					>
					<component v-bind:is="componentName" v-on:closed="closeDialog"></component>
				</v-dialog>
			</keep-alive>

		</v-app-bar>
		
		<!--for non home-->
		<v-app-bar app color="brown lighten-1" light v-else>
			
			<v-btn icon color="white" light v-on:click.stop="$router.go(-1)">
				<v-icon>mdi-arrow-left-circle</v-icon>				
			</v-btn>
			
			<v-spacer></v-spacer>

			<v-btn 	icon color="white" v-if="donationCounter>0"
					v-on:click="setComponent({component:'tx-component', status:true})"
				>
				<v-badge color="orange" overlap>
					<template v-slot:badge>
						<span>{{donationCounter}}</span>
					</template>
					<v-icon>mdi-cash-multiple</v-icon>
				</v-badge>
			</v-btn>
			<v-btn icon v-else>
				<v-icon>mdi-cash-multiple</v-icon>
			</v-btn>
			
		</v-app-bar>


		<!-- Sizes your content based upon application components -->
		<v-main>

			<!-- Provides the application the proper gutter -->
			<v-container fluid>
				
				<!-- If using vue-router -->
				<v-slide-y-transition>
					<router-view></router-view>
				</v-slide-y-transition>

			</v-container>

			<alert/>

		</v-main>

		<v-card>
			<v-footer absolute app>
				<v-card-text class="text-center">
					&copy; {{new Date().getFullYear()}} - <strong>{{title}}</strong>
				</v-card-text>
			</v-footer>
		</v-card>
	</v-app>
  
</template>

<script>
import search from './components/SearchCampaignComponent.vue'
import myLogin from './components/auth/Login.vue'
import myRegistration from './components/auth/Register.vue'
import {mapGetters, mapActions} from 'vuex'
import alert from './components/Alert.vue'
/* import chat from './components/chat/ChatRoomExample.vue' */
import chat from './components/chat/ChatRoom.vue'
import trxComponent from './components/transaction/TransactionComponent.vue'

export default {
	name:'App',
	components:{
		'search-campaign':search,
		'my-login':myLogin,
		'my-registration':myRegistration,
		alert,
		'chat-room':chat,
		'tx-component':trxComponent
	},
	data:function(){
		return{
			title:'Crowd Funding App',
			drawer:false,
			menus:[
				{	title:'Home', icon:'mdi-home', route:{name:'home'} },
				{	title:'Donations', icon:'mdi-hand-heart', route:{name:'donations'} },
				{	title:'Profile', icon:'mdi-account-details', route:{name:'cf.profile.edit'} },				
			],						
		}
	},mounted:function(){
		console.log('App Mounted')
		this.checkToken(this.authenticated)
		
	},computed:{
		isHome:function(){
			let currentPath = this.$route.path
			console.log(`Called Path is : ${currentPath}`)
			if(currentPath==='/' || currentPath==='/home'){
				return true
			}else{
				return false
			}
		},
		isGuest:function(){
			if(!this.authenticated)
				return true
			else
				return false	

		},
		...mapGetters({
			donationCounter:'donationTransaction/donationCounter',
			authenticated:'authenticate/haveToken',
			whoAmI:'authenticate/whoAmI',
			componentName:'component/getComponent',
			componentStatus:'component/getStatus'
		})		
	},methods:{
		getHeader(){
			return{
				headers :{

					'Accept': 'application/json',
					'Access-Control-Allow-Headers': 'Authorization',
					'Authorization':`Bearer ${this.authenticated}`	
										
				}				
			}
		},
		async doLogout(){

			try {
				
				let response = await axios.post('/api/auth/logout',{},this.getHeader())

				let {status} = response
				
				if(status==200){

					let {response_code, response_message} = response.data
				
					if(response_code==="00"){

						this.logout()
				
						this.alert({
							title:'success',
							message:response_message
						})

					}
					
				}else{

					let {response_message} = response
					
					this.alert({
						title:'error',
						message:response_message
					})

				}

			} catch (err) {
				console.log(err)

				let {data, message} = err.response

				this.alert.show({
					title:'error',
					message:response_message
				})

			}
			
		}
		,...mapActions({
			logout:'authenticate/logout',
			checkToken:'authenticate/checkToken',
			setComponent:'component/setComponent',
			alert:'alert/show'
		}),
		closeDialog:function(valueFromDialog){
			this.setComponent({
				component:this.componentName,
				status:valueFromDialog
			})
		}
	}
}

</script>

<style>

</style>

